#include "shared/classicmode/classicfactory.h"
#include "game/classicgame.h"
#include "game/classicgraphicsmanager.h"
#include "tools/music.h"

#include <SFML/Graphics/RenderWindow.hpp>

std::unique_ptr<Game> classic::init(sf::RenderWindow& game_window)
{
    return std::make_unique<ClassicGame>(std::make_unique<ClassicGraphicsManager>(game_window), std::make_unique<Music>());
}
