#ifndef CLASSICMAPCREATOR_H
#define CLASSICMAPCREATOR_H

#include <set>

#include "tools/mathutils.h"
#include "core/note.h"

#include "classicgraphicsmanager.h"

struct Beatmap
{
    std::set<ClassicNote*, NotePtrCompt> notes;
    microsec visibility_offset;
};

class ClassicMapCreator
{
public:
    explicit ClassicMapCreator(const std::shared_ptr<ClassicGraphicsManager>& manager);

     Beatmap createBeatmap(const std::string& filepath) const;

private:
    const std::shared_ptr<ClassicGraphicsManager> _graphics_manager;
};

#endif // CLASSICMAPCREATOR_H
