#pragma once

#include "window.h"
#include "bpmslider.h"
#include "pushbutton.h"
#include <functional>
#include <SFML/Graphics/RectangleShape.hpp>
#include <SFML/Graphics/Text.hpp>
#include <SFML/Audio/Sound.hpp>
#include <SFML/Audio/SoundBuffer.hpp>

class BPMCalculator;

class BPMCalculatorWidget : public Window
{
public:
    explicit BPMCalculatorWidget(const std::shared_ptr<BPMCalculator>& bpm_calculator, const std::shared_ptr<sf::Font> &font);

    virtual void input(const sf::Event& event) override;
    virtual void update(const sf::Time& dt) override;
    virtual void draw(sf::RenderTarget& target, sf::RenderStates states) const override;
    virtual void setRect(const sf::FloatRect& rect) override;
    virtual void setPosition(const sf::Vector2f& position) override;
    virtual void move(const sf::Vector2f& delta) override;

    virtual void setVisibility(bool is_visible = true) override;

    void init();

private:
    std::shared_ptr<PushButton> _button_start;
    std::shared_ptr<PushButton> _button_stop;
    std::shared_ptr<BPMCalculator> _bpm_calculator;
    std::shared_ptr<BPMSlider> _slider;

    sf::SoundBuffer _slap_buffer;
    sf::Sound _slap;
    bool _ticked;

    sf::Text _bpm_value;
};

