#pragma once

#include "widget.h"

#include <SFML/Graphics/RectangleShape.hpp>
#include <SFML/Graphics/Text.hpp>

class BPMSlider : public Widget
{
public:
    explicit BPMSlider();

    virtual void input(const sf::Event& event) override;
    virtual void update(const sf::Time& dt) override;
    virtual void draw(sf::RenderTarget& target, sf::RenderStates states) const override;
    virtual void move(const sf::Vector2f& delta) override;
    virtual bool isUnderMouse(int mouse_x, int mouse_y) const override;

    virtual void setRect(const sf::FloatRect& rect) override;
    virtual sf::FloatRect rect() const override;

    virtual void setPosition(const sf::Vector2f& position) override;
    virtual sf::Vector2f position() const override;

    void setTickPosition(float x_position);

private:
    sf::RectangleShape _slider_background;
    sf::RectangleShape _slider_tick;
};


