#pragma once

#include "widget.h"

#include <SFML/Graphics/RectangleShape.hpp>
#include <SFML/Graphics/Text.hpp>

class Window : public Widget
{
public:
    explicit Window(const std::string& text, const std::shared_ptr<sf::Font> &font);

    virtual void input(const sf::Event& event) override;
    virtual void update(const sf::Time& dt) override;
    virtual void draw(sf::RenderTarget& target, sf::RenderStates states) const override;
    virtual void move(const sf::Vector2f& delta) override;
    virtual bool isUnderMouse(int mouse_x, int mouse_y) const override final;

    virtual void setRect(const sf::FloatRect& rect) override;
    virtual sf::FloatRect rect() const override;

    virtual void setPosition(const sf::Vector2f& position) override;
    virtual sf::Vector2f position() const override;

    void addBarButton(const std::string& text, std::function<void(void)> callback);

protected:
    sf::RectangleShape _bar;
    sf::RectangleShape _window_content;
    sf::Text _bar_title;

    const std::shared_ptr<sf::Font> _font;

private:
    bool _is_dragging;
    sf::Vector2f _previous_click_position;
};

